## rhash 1.3.1

=== Makefile ===
# Sample usage:
# compile with debug info: make CFLAGS=-g
# compile for pentiumpro: make CFLAGS="-O2 -DNDEBUG -march=i586 -mcpu=pentiumpro -fomit-frame-pointer"
# create rpm with statically linked program: make rpm ADDLDFLAGS="-static -s -Wl,--gc-sections"
VERSION = 1.3.1
PREFIX  = /usr/local
CC      = gcc
# using OPTFLAGS/OPTLDFLAGS for compatibilty with old scripts using this makefile
OPTFLAGS = -O2 -DNDEBUG -fomit-frame-pointer -ffunction-sections -fdata-sections
OPTLDFLAGS =
CFLAGS = $(OPTFLAGS)
LDFLAGS = $(OPTLDFLAGS)
ADDCFLAGS =
ADDLDFLAGS =
ALLCFLAGS = -pipe $(CFLAGS) $(ADDCFLAGS) \
  -Wall -W -Wstrict-prototypes -Wnested-externs -Winline -Wpointer-arith \
  -Wbad-function-cast -Wmissing-prototypes -Wmissing-declarations
LDLIBRHASH = -Llibrhash -lrhash
ALLLDFLAGS = $(LDLIBRHASH) $(LDFLAGS) $(ADDLDFLAGS)
SHAREDLIB  = librhash/librhash.so.0
SHRDLFLAGS = $(SHAREDLIB) $(LDFLAGS) $(ADDLDFLAGS)
HEADERS = calc_sums.h hash_print.h common_func.h hash_update.h file_mask.h file_set.h find_file.h hash_check.h output.h parse_cmdline.h rhash_main.h win_utils.h version.h
SOURCES = calc_sums.c hash_print.c common_func.c hash_update.c file_mask.c file_set.c find_file.c hash_check.c output.c parse_cmdline.c rhash_main.c win_utils.c
OBJECTS = calc_sums.o hash_print.o common_func.o hash_update.o file_mask.o file_set.o find_file.o hash_check.o output.o parse_cmdline.o rhash_main.o win_utils.o
OUTDIR   =
PROGNAME = rhash
TARGET   = $(OUTDIR)$(PROGNAME)
SHARED_TRG = $(TARGET)_shared
SYMLINKS = sfv-hash tiger-hash tth-hash whirlpool-hash has160-hash gost-hash ed2k-link magnet-link
SPECFILE = dist/rhash.spec
LIN_DIST_FILES = Makefile ChangeLog INSTALL COPYING README \
  $(SPECFILE) $(SPECFILE).in $(SOURCES) $(HEADERS) tests/test_rhash.sh \
  dist/rhash.1 dist/rhash.1.win.sed dist/rhash.1.html
WIN_DIST_FILES = dist/MD5.bat dist/magnet.bat dist/rhashrc.sample
WIN_SRC_FILES  = win32/dirent.h win32/stdint.h win32/unistd.h win32/platform-dependent.h \
  win32/vc-2010/rhash.vcxproj
LIBRHASH_FILES  = librhash/algorithms.c librhash/algorithms.h \
  librhash/byte_order.c librhash/byte_order.h librhash/rhash_timing.c librhash/rhash_timing.h \
  librhash/plug_openssl.c librhash/plug_openssl.h librhash/rhash.c librhash/rhash.h \
  librhash/aich.c librhash/aich.h librhash/crc32.c librhash/crc32.h \
  librhash/ed2k.c librhash/ed2k.h librhash/edonr.c librhash/edonr.h \
  librhash/gost.c librhash/gost.h librhash/has160.c librhash/has160.h \
  librhash/hex.c librhash/hex.h librhash/md4.c librhash/md4.h \
  librhash/md5.c librhash/md5.h librhash/ripemd-160.c librhash/ripemd-160.h \
  librhash/sha1.c librhash/sha1.h librhash/sha3.c librhash/sha3.h \
  librhash/sha256.c librhash/sha256.h librhash/sha512.c librhash/sha512.h \
  librhash/snefru.c librhash/snefru.h librhash/tiger.c librhash/tiger.h \
  librhash/tiger_sbox.c librhash/tth.c librhash/tth.h librhash/whirlpool.c \
  librhash/whirlpool.h librhash/whirlpool_sbox.c librhash/test_hashes.c \
  librhash/test_hashes.h librhash/torrent.h librhash/torrent.c librhash/ustd.h \
  librhash/util.c librhash/util.h librhash/config.h librhash/Makefile
I18N_FILES = po/de.po po/en_AU.po po/es.po po/gl.po po/it.po po/ru.po
DIST_FILES     = $(LIN_DIST_FILES) $(LIBRHASH_FILES) $(WIN_DIST_FILES) $(WIN_SRC_FILES) $(I18N_FILES)
DESTDIR = 
BINDIR  = $(PREFIX)/bin
MANDIR  = $(PREFIX)/share/man
LOCALEDIR = $(PREFIX)/share/locale
RPMTOP  = rpms
RPMDIRS = SOURCES SPECS BUILD SRPMS RPMS
LIBRHASH = librhash/librhash.a
# Set variables according to GNU coding standard
INSTALL = install
INSTALL_PROGRAM = $(INSTALL) -m 755
INSTALL_DATA    = $(INSTALL) -m 644

all: $(TARGET)
build-shared: $(SHARED_TRG)
lib-shared: $(SHAREDLIB)
lib-static: $(LIBRHASH)

install: all install-binary install-data install-symlinks
install-shared: $(SHARED_TRG) install-shared-binary install-data install-symlinks
uninstall: uninstall-binary uninstall-data uninstall-symlinks

# creating archives
WIN_SUFFIX     = win32
ARCHIVE_BZIP   = rhash-$(VERSION)-src.tar.bz2
ARCHIVE_GZIP   = rhash-$(VERSION)-src.tar.gz
ARCHIVE_FULL   = rhash-$(VERSION)-full-src.tar.gz
ARCHIVE_DEB_GZ = rhash_$(VERSION).orig.tar.gz
ARCHIVE_7Z     = rhash-$(VERSION)-src.tar.7z
ARCHIVE_ZIP    = rhash-$(VERSION)-$(WIN_SUFFIX).zip
WIN_ZIP_DIR    = RHash-$(VERSION)-$(WIN_SUFFIX)
dist: gzip gzip-bindings
dist-full: gzip-full
win-dist: zip
zip : $(ARCHIVE_ZIP)
dgz:  check $(ARCHIVE_DEB_GZ)

install-binary:
	$(INSTALL) -d $(DESTDIR)$(BINDIR)
	$(INSTALL_PROGRAM) $(TARGET) $(DESTDIR)$(BINDIR)

# install dynamically linked binary
install-shared-binary:
	$(INSTALL) -d $(DESTDIR)$(BINDIR)
	$(INSTALL_PROGRAM) $(SHARED_TRG) $(DESTDIR)$(BINDIR)/rhash

install-data:
	$(INSTALL) -d $(DESTDIR)$(MANDIR)/man1 $(DESTDIR)/etc
	$(INSTALL_DATA) dist/rhash.1 $(DESTDIR)$(MANDIR)/man1/rhash.1
	sed -e 's/\x0D//g' dist/rhashrc.sample > rhashrc && $(INSTALL_DATA) rhashrc $(DESTDIR)/etc/rhashrc
	rm -f rhashrc

# dependencies should be properly set, otherwise 'make -j<n>' can run install targets in parallel
install-symlinks:
	for f in $(SYMLINKS); do ln -fs rhash $(DESTDIR)$(BINDIR)/$$f; done
	cd $(DESTDIR)$(MANDIR)/man1 && for f in $(SYMLINKS); do ln -fs rhash.1* $$f.1; done

uninstall-binary:
	rm -f $(DESTDIR)$(BINDIR)/$(PROGNAME)

uninstall-data:
	rm -f $(DESTDIR)$(MANDIR)/man1/rhash.1

uninstall-symlinks:
	for f in $(SYMLINKS); do rm -f $(DESTDIR)$(BINDIR)/$$f; done

install-lib-static: $(LIBRHASH)
	+make -C librhash install-lib-static

install-lib-shared: $(SHAREDLIB)
	+make -C librhash install-lib-shared

$(SHAREDLIB):
	+make -C librhash lib-shared

$(LIBRHASH): $(LIBRHASH_FILES)
	+make -C librhash lib-static

test-static-lib: $(LIBRHASH)
	+make -C librhash test-static

test-shared-lib: $(SHAREDLIB)
	+make -C librhash test-shared

test-libs: $(LIBRHASH) $(SHAREDLIB)
	+make -C librhash test-static test-shared

test: test-static
test-static: $(TARGET)
	chmod +x tests/test_$(PROGNAME).sh
	tests/test_$(PROGNAME).sh

test-shared: $(SHARED_TRG) test-shared-lib
	chmod +x tests/test_$(PROGNAME).sh
	LD_LIBRARY_PATH=../librhash:$(LD_LIBRARY_PATH) tests/test_rhash.sh ./$(SHARED_TRG)

version.h: Makefile
	echo "#define VERSION \"$(VERSION)\"" > version.h

# check version
check: version.h
	grep -q '\* === Version $(VERSION) ===' ChangeLog
	grep -q '^#define VERSION "$(VERSION)"' version.h
	[ ! -d bindings -o bindings/version.properties -nt Makefile ] || \
		echo "version=$(VERSION)" > bindings/version.properties
	[ -s dist/rhash.1.html ]

$(TARGET): $(OBJECTS) $(LIBRHASH)
	$(CC) $(OBJECTS) -o $@ $(ALLLDFLAGS)

$(SHARED_TRG): $(OBJECTS) $(SHAREDLIB)
	$(CC) $(OBJECTS) -o $(SHARED_TRG) $(SHRDLFLAGS)

# NOTE: dependences were generated by 'gcc -Ilibrhash -MM *.c'
# we are using plain old makefile style to support BSD make
calc_sums.o: calc_sums.c common_func.h librhash/util.h librhash/hex.h \
 librhash/rhash.h librhash/rhash_timing.h parse_cmdline.h rhash_main.h \
 file_set.h calc_sums.h hash_check.h hash_print.h output.h win_utils.h \
 version.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

common_func.o: common_func.c common_func.h librhash/util.h librhash/hex.h \
 win_utils.h parse_cmdline.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

hash_print.o: hash_print.c common_func.h librhash/util.h librhash/hex.h \
 librhash/byte_order.h calc_sums.h librhash/rhash.h hash_check.h \
 parse_cmdline.h hash_print.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

hash_update.o: hash_update.c common_func.h librhash/util.h \
 librhash/rhash_timing.h win_utils.h parse_cmdline.h output.h rhash_main.h \
 file_set.h calc_sums.h librhash/rhash.h hash_check.h file_mask.h \
 hash_update.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

file_mask.o: file_mask.c common_func.h librhash/util.h file_mask.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

file_set.o: file_set.c librhash/hex.h librhash/crc32.h common_func.h \
 librhash/util.h hash_print.h parse_cmdline.h rhash_main.h output.h \
 file_set.h calc_sums.h librhash/rhash.h hash_check.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

find_file.o: find_file.c common_func.h librhash/util.h win_utils.h \
 find_file.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

hash_check.o: hash_check.c librhash/hex.h librhash/byte_order.h \
 librhash/rhash.h output.h parse_cmdline.h hash_print.h hash_check.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

output.o: output.c common_func.h librhash/util.h librhash/rhash.h \
 calc_sums.h hash_check.h parse_cmdline.h rhash_main.h output.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

parse_cmdline.o: parse_cmdline.c common_func.h librhash/util.h \
 librhash/rhash.h librhash/plug_openssl.h win_utils.h file_mask.h \
 hash_print.h output.h rhash_main.h version.h parse_cmdline.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

rhash_main.o: rhash_main.c common_func.h librhash/util.h \
 librhash/rhash_timing.h win_utils.h find_file.h file_set.h calc_sums.h \
 librhash/rhash.h hash_check.h hash_update.h file_mask.h hash_print.h \
 parse_cmdline.h output.h version.h rhash_main.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

win_utils.o: win_utils.c common_func.h librhash/util.h parse_cmdline.h \
 rhash_main.h win_utils.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

dist/rhash.1.win.html: dist/rhash.1 dist/rhash.1.win.sed
	sed -f dist/rhash.1.win.sed dist/rhash.1 | rman -fHTML -roff | \
	sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > dist/rhash.1.win.html
#	verify the result
	grep -q "utf8" dist/rhash.1.win.html
	grep -q "APPDATA" dist/rhash.1.win.html

dist/rhash.1.html: dist/rhash.1
	-which rman 2>/dev/null && (rman -fHTML -roff dist/rhash.1 | sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > $@)

dist/rhash.1.txt: dist/rhash.1
	-which groff &>/dev/null && (groff -t -e -mandoc -Tascii dist/rhash.1 | sed -e 's/.\[[0-9]*m//g' > $@)

cpp-doc:
	cppdoc_cmd -title=RHash -company=Animegorodok -classdir=classdoc -module="cppdoc-standard" -overwrite -extensions="c,h" -languages="c=cpp,h=cpp" -generate-deprecations-list=false $(SOURCES) $(HEADERS) ./Documentation/CppDoc/index.html

permissions:
	find . dist librhash po win32 win32/vc-2010 -maxdepth 1 -type f -exec chmod -x '{}' \;
	chmod +x tests/test_$(PROGNAME).sh

clean-bindings:
	+make -C bindings distclean

copy-dist: $(DIST_FILES) permissions
	rm -rf $(PROGNAME)-$(VERSION)
	mkdir $(PROGNAME)-$(VERSION)
	cp -rl --parents $(DIST_FILES) $(PROGNAME)-$(VERSION)/

gzip: check
	+make copy-dist
	tar czf $(ARCHIVE_GZIP) $(PROGNAME)-$(VERSION)/
	rm -rf $(PROGNAME)-$(VERSION)

gzip-bindings:
	+make -C bindings gzip ARCHIVE_GZIP=../rhash-bindings-$(VERSION)-src.tar.gz

gzip-full: check clean-bindings
	+make copy-dist
	+make -C bindings copy-dist COPYDIR=../$(PROGNAME)-$(VERSION)/bindings
	tar czf $(ARCHIVE_FULL) $(PROGNAME)-$(VERSION)/
	rm -rf $(PROGNAME)-$(VERSION)

bzip: check
	+make copy-dist
	tar cjf $(ARCHIVE_BZIP) $(PROGNAME)-$(VERSION)/
	rm -rf $(PROGNAME)-$(VERSION)

7z: check
	+make copy-dist
	tar cf - $(PROGNAME)-$(VERSION)/ | 7zr a -si $(ARCHIVE_7Z)
	rm -rf $(PROGNAME)-$(VERSION)

$(ARCHIVE_ZIP): $(WIN_DIST_FILES) dist/rhash.1.win.html
	[ -s dist/rhash.1.win.html -a -x $(TARGET) ]
	-rm -rf $(WIN_ZIP_DIR)
	mkdir $(WIN_ZIP_DIR)
	cp $(TARGET).exe ChangeLog $(WIN_DIST_FILES) $(WIN_ZIP_DIR)/
	cp dist/rhash.1.win.html $(WIN_ZIP_DIR)/rhash-doc.html
#	-[ -f $(OUTDIR)libeay32.dll ] && cp $(OUTDIR)libeay32.dll $(WIN_ZIP_DIR)/
	zip -9r $(ARCHIVE_ZIP) $(WIN_ZIP_DIR)
	rm -rf $(WIN_ZIP_DIR)

$(ARCHIVE_DEB_GZ) : $(DIST_FILES)
	+make $(ARCHIVE_GZIP)
	mv -f $(ARCHIVE_GZIP) $(ARCHIVE_DEB_GZ)

# rpm packaging
$(SPECFILE): $(SPECFILE).in Makefile
	sed -e 's/@VERSION@/$(VERSION)/' $(SPECFILE).in > $(SPECFILE)

rpm: gzip
	-for i in $(RPMDIRS); do mkdir -p $(RPMTOP)/$$i; done
	cp -f $(ARCHIVE_GZIP) $(RPMTOP)/SOURCES
	rpmbuild -ba --clean --define "_topdir `pwd`/$(RPMTOP)" $(SPECFILE)
	mv -f `find $(RPMTOP) -name "*rhash*-$(VERSION)*.rpm"` .
	rm -rf $(RPMTOP)

distclean: clean

clean:
	+make -C librhash clean
	rm -f *.o $(SHARED_TRG) $(TARGET)
	rm -f po/*.gmo po/*.po~

update-po:
	xgettext *.c -k_ -cTRANSLATORS -o po/rhash.pot \
		--msgid-bugs-address='Aleksey <rhash.admin@gmail.com>' --package-name='RHash'
	for f in po/*.po; do \

=== librhash/Makefile ===
# Makefile for LibRHash
CC      = gcc
AR      = ar
#NOTE: NDEBUG turns off asserts
OPTFLAGS   = -O2 -DNDEBUG -fomit-frame-pointer -ffunction-sections -fdata-sections
OPTLDFLAGS =
CFLAGS     = $(OPTFLAGS)
LDFLAGS    = $(OPTLDFLAGS)
ADDCFLAGS  =
LIBCFLAGS  =
ADDLDFLAGS =
DEFS    = -DIN_RHASH
PRGCFLAGS  = -pipe $(DEFS) $(ADDCFLAGS) $(CFLAGS) \
  -Wall -W -Wstrict-prototypes -Wnested-externs -Winline -Wpointer-arith \
  -Wbad-function-cast -Wmissing-prototypes -Wmissing-declarations
ALLCFLAGS = $(LIBCFLAGS) $(PRGCFLAGS)
LDRHASH    = -L. -lrhash
LIBLDFLAGS = $(LDFLAGS) $(ADDLDFLAGS)
HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_timing.h util.h aich.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h sha3.h ripemd-160.h gost.h has160.h snefru.h tiger.h              tth.h torrent.h whirlpool.h
SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_timing.c util.c aich.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c sha3.c ripemd-160.c gost.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c whirlpool.c whirlpool_sbox.c
OBJECTS = algorithms.o byte_order.o plug_openssl.o rhash.o rhash_timing.o util.o aich.o crc32.o ed2k.o edonr.o hex.o md4.o md5.o sha1.o sha256.o sha512.o sha3.o ripemd-160.o gost.o has160.o snefru.o tiger.o tiger_sbox.o tth.o torrent.o whirlpool.o whirlpool_sbox.o
LIB_HEADERS = rhash.h rhash_timing.h
# installation directories and names
DESTDIR =
PREFIX  = /usr/local
INCDIR  = $(PREFIX)/include
LIBDIR  = $(PREFIX)/lib
LIBRARY = librhash.a
SONAME  = librhash.so.0
SOLINK  = librhash.so
TEST_TARGET = test_hashes
TEST_SHARED = test_shared
# Set variables according to GNU coding standard
INSTALL = install
INSTALL_DATA    = $(INSTALL) -m 644
INSTALL_SHARED  = $(INSTALL) -m 644

all: $(LIBRARY)
lib-static: $(LIBRARY)
lib-shared: $(SONAME)
libs-all: lib-static lib-shared
dist-clean: clean

install-lib-static: $(LIBRARY) install-headers
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)
	$(INSTALL_DATA) $(LIBRARY) $(DESTDIR)$(LIBDIR)/
	ln -s $(SONAME) $(DESTDIR)$(LIBDIR)/$(SOLINK)

install-lib-shared: $(SONAME)
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)
	$(INSTALL_SHARED) $(SONAME) $(DESTDIR)$(LIBDIR)/

uninstall-lib-static: uninstall-headers
	rm -f $(DESTDIR)$(LIBDIR)/$(LIBRARY)
	rm -f $(DESTDIR)$(LIBDIR)/$(SOLINK)

uninstall-lib-shared:
	rm -f $(DESTDIR)$(LIBDIR)/$(SONAME)

install-headers:
	$(INSTALL) -d $(DESTDIR)$(INCDIR)
	$(INSTALL_DATA) $(LIB_HEADERS) $(DESTDIR)$(INCDIR)/

uninstall-headers:
	for f in $(LIB_HEADERS); do rm -f "$(DESTDIR)$(INCDIR)/$$f"; done

# not using GNU make extensions for compatibility with Unix/*BSD make
#%.o: %.c
#	$(CC) -c $(ALLCFLAGS) $< -o $@

# NOTE: dependences were generated by 'gcc -MM -DIN_RHASH -DUSE_OPENSSL *.c'
# we are using plain old makefile style to support BSD make
aich.o: aich.c byte_order.h ustd.h config.h algorithms.h rhash.h aich.h \
 sha1.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

algorithms.o: algorithms.c byte_order.h ustd.h config.h rhash.h \
 algorithms.h aich.h sha1.h crc32.h ed2k.h md4.h edonr.h gost.h has160.h \
 md5.h ripemd-160.h snefru.h sha256.h sha512.h sha3.h tiger.h torrent.h \
 tth.h whirlpool.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

byte_order.o: byte_order.c byte_order.h ustd.h config.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

crc32.o: crc32.c byte_order.h ustd.h config.h crc32.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

ed2k.o: ed2k.c ed2k.h md4.h ustd.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

edonr.o: edonr.c byte_order.h ustd.h config.h edonr.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

gost.o: gost.c byte_order.h ustd.h config.h gost.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

has160.o: has160.c byte_order.h ustd.h config.h has160.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

hex.o: hex.c hex.h ustd.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

md4.o: md4.c byte_order.h ustd.h config.h md4.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

md5.o: md5.c byte_order.h ustd.h config.h md5.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

plug_openssl.o: plug_openssl.c algorithms.h rhash.h byte_order.h ustd.h \
 config.h plug_openssl.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

rhash.o: rhash.c byte_order.h ustd.h config.h algorithms.h rhash.h \
 torrent.h sha1.h plug_openssl.h util.h hex.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

rhash_timing.o: rhash_timing.c byte_order.h ustd.h config.h rhash.h \
 rhash_timing.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

ripemd-160.o: ripemd-160.c byte_order.h ustd.h config.h ripemd-160.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

sha1.o: sha1.c byte_order.h ustd.h config.h sha1.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

sha256.o: sha256.c byte_order.h ustd.h config.h sha256.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

sha512.o: sha512.c byte_order.h ustd.h config.h sha512.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

sha3.o: sha3.c byte_order.h ustd.h config.h sha3.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

snefru.o: snefru.c byte_order.h ustd.h config.h snefru.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

test_hashes.o: test_hashes.c byte_order.h ustd.h config.h rhash_timing.h \
 rhash.h test_hashes.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

tiger.o: tiger.c byte_order.h ustd.h config.h tiger.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

tiger_sbox.o: tiger_sbox.c byte_order.h ustd.h config.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

torrent.o: torrent.c byte_order.h ustd.h config.h algorithms.h rhash.h \
 hex.h torrent.h sha1.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

tth.o: tth.c byte_order.h ustd.h config.h tth.h tiger.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

util.o: util.c util.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

whirlpool.o: whirlpool.c byte_order.h ustd.h config.h whirlpool.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

whirlpool_sbox.o: whirlpool_sbox.c byte_order.h ustd.h config.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

# MINGW dll target
DLLNAME = librhash.dll

dll: $(DLLNAME)
$(DLLNAME): $(SOURCES)
	sed -n '1s/.*/{ global:/p; s/^RHASH_API.* \([a-z0-9_]\+\)(.*/  \1;/p; $$s/.*/local: *; };/p' $(LIB_HEADERS) > exports.sym
	$(CC) -DRHASH_EXPORTS $(ALLCFLAGS) -shared $(SOURCES) -Wl,--version-script,exports.sym,--output-def,librhash.def,-soname,$@ $(LIBLDFLAGS) -o $@

test-dll: $(DLLNAME) test_hashes.o
	$(CC) $(PRGCFLAGS) test_hashes.o $(DLLNAME) -o $(TEST_SHARED) && ./$(TEST_SHARED)

# shared and static libraries
$(SONAME): $(SOURCES)
	sed -n '1s/.*/{ global:/p; s/^RHASH_API.* \([a-z0-9_]\+\)(.*/  \1;/p; $$s/.*/local: *; };/p' $(LIB_HEADERS) > exports.sym
	$(CC) -fpic $(ALLCFLAGS) -shared $(SOURCES) -Wl,--version-script,exports.sym,-soname,$(SONAME) $(LIBLDFLAGS) -o $@
	ln -s $(SONAME) $(SOLINK)
# use 'nm -Cg --defined-only $@' to view exported symbols

$(LIBRARY): $(OBJECTS)
	$(AR) cqs $@ $(OBJECTS)
#	$(AR) cr $(LIBRARY) $(OBJECTS) && runlib $(LIBRARY)

$(TEST_TARGET): $(LIBRARY) test_hashes.o
	$(CC) $(ALLCFLAGS) test_hashes.o $(LIBRARY) $(LIBLDFLAGS) -o $@

test-shared: $(SONAME) test_hashes.o
	$(CC) $(PRGCFLAGS) test_hashes.o $(SONAME) $(LIBLDFLAGS) -o $(TEST_SHARED)
	LD_LIBRARY_PATH=.:$(LD_LIBRARY_PATH) ./$(TEST_SHARED)

test-static: $(TEST_TARGET)
	./$(TEST_TARGET)

test: test-static
	if [ -f $(SONAME) ]; then make test-shared; fi
#	if [ -f $(DLLNAME) ]; then make test-dll; fi

clean:
	rm -f *.o $(LIBRARY) $(TEST_TARGET) $(TEST_SHARED) $(SONAME) $(SOLINK) exports.sym $(DLLNAME) librhash.def

=== debian/changelog ===
rhash (1.3.1-1) unstable; urgency=low

  * New upstream release version 1.3.1
   - bump Standards-Version to 3.9.5

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Wed, 08 Jan 2014 23:47:28 +0700

rhash (1.3.0-3) unstable; urgency=low

  * Fixed 'Value too large...' error (Closes: #727012)

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Sun, 24 Nov 2013 20:19:26 +0700

rhash (1.3.0-2) unstable; urgency=low

  * Fixed sha3 on big-endian processors

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Sun, 22 Sep 2013 00:51:37 +0700

rhash (1.3.0-1) unstable; urgency=low

  * New upstream release version 1.3.0
   - switched the package back to unstable

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Mon, 16 Sep 2013 19:48:55 +0700

rhash (1.2.10-1) experimental; urgency=low

  * New upstream release version 1.2.10
   - switched to Debhelper 9 and Standards-Version 3.9.4
   - moved language bindings to separate rhash-bindings package

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Tue, 25 Dec 2012 01:55:52 +0700

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules makefile that uses debhelper.
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
CFLAGS = -DUSE_GETTEXT -DNDEBUG -D_FORTIFY_SOURCE=2 -Wall -fomit-frame-pointer $(shell dpkg-buildflags --get CFLAGS)
LDFLAGS= $(shell dpkg-buildflags --get LDFLAGS)
LIBCFLAGS =
LIBLDFLAGS = $(LDFLAGS)
INSTALL_PROGRAM = install -p -m 755
DESTDIR = $(CURDIR)/debian/tmp
LD_LIB=$(DESTDIR):$(LD_LIBRARY_PATH)

# see Debian Policy Manual - source packages
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

# by default compile RHash with openssl runtime linking
ifeq (,$(findstring nossl,$(DEB_BUILD_OPTIONS)))
	LIBCFLAGS += -DUSE_OPENSSL
ifneq (,$(findstring ssldynamic,$(DEB_BUILD_OPTIONS)))
	LIBLDFLAGS += -lcrypto
else
	LIBCFLAGS  += -DOPENSSL_RUNTIME -rdynamic
	LIBLDFLAGS += -ldl
endif
endif

# using debhelper >= 8 to build the package
%:
	dh $@

build:
	# Compile static/shared libraries and the program.
	$(MAKE) lib-static lib-shared build-shared CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		LIBCFLAGS="$(LIBCFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)"

override_dh_auto_build:
override_dh_auto_test:
	$(MAKE) test-static-lib CFLAGS="$(CFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)"
	$(MAKE) test-shared CFLAGS="$(CFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)" LD_LIBRARY_PATH="$(LD_LIB)"

override_dh_auto_install:
	# Install the program and its translation strings
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/rhash INSTALL_PROGRAM="$(INSTALL_PROGRAM)" install-shared install-gmo
	# Install static library
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/librhash-dev install-lib-static
	# Install shared library
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/librhash0 install-lib-shared

override_dh_strip:
	dh_strip -plibrhash0 --dbg-package=librhash0-dbg
	dh_strip

override_dh_auto_clean:
	$(MAKE) distclean

=== debian/watch ===
version=3
http://sf.net/rhash/rhash-([\d\.]+)-src\.tar\.gz

## rhash 1.3.3

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # compile with debug info: make CFLAGS=-g
 # compile for pentiumpro: make CFLAGS="-O2 -DNDEBUG -march=i586 -mcpu=pentiumpro -fomit-frame-pointer"
 # create rpm with statically linked program: make rpm ADDLDFLAGS="-static -s -Wl,--gc-sections"
-VERSION = 1.3.1
+VERSION = 1.3.3
 PREFIX  = /usr/local
 CC      = gcc
 # using OPTFLAGS/OPTLDFLAGS for compatibilty with old scripts using this makefile
@@ -18,7 +18,7 @@
 LDLIBRHASH = -Llibrhash -lrhash
 ALLLDFLAGS = $(LDLIBRHASH) $(LDFLAGS) $(ADDLDFLAGS)
 SHAREDLIB  = librhash/librhash.so.0
-SHRDLFLAGS = $(SHAREDLIB) $(LDFLAGS) $(ADDLDFLAGS)
+SHRDLFLAGS = $(LDFLAGS) $(ADDLDFLAGS)
 HEADERS = calc_sums.h hash_print.h common_func.h hash_update.h file_mask.h file_set.h find_file.h hash_check.h output.h parse_cmdline.h rhash_main.h win_utils.h version.h
 SOURCES = calc_sums.c hash_print.c common_func.c hash_update.c file_mask.c file_set.c find_file.c hash_check.c output.c parse_cmdline.c rhash_main.c win_utils.c
 OBJECTS = calc_sums.o hash_print.o common_func.o hash_update.o file_mask.o file_set.o find_file.o hash_check.o output.o parse_cmdline.o rhash_main.o win_utils.o
@@ -29,14 +29,16 @@
 SYMLINKS = sfv-hash tiger-hash tth-hash whirlpool-hash has160-hash gost-hash ed2k-link magnet-link
 SPECFILE = dist/rhash.spec
 LIN_DIST_FILES = Makefile ChangeLog INSTALL COPYING README \
-  $(SPECFILE) $(SPECFILE).in $(SOURCES) $(HEADERS) tests/test_rhash.sh \
+  $(SPECFILE) $(SPECFILE).in $(SOURCES) $(HEADERS) \
+  tests/test_rhash.sh tests/test1K.data \
   dist/rhash.1 dist/rhash.1.win.sed dist/rhash.1.html
 WIN_DIST_FILES = dist/MD5.bat dist/magnet.bat dist/rhashrc.sample
 WIN_SRC_FILES  = win32/dirent.h win32/stdint.h win32/unistd.h win32/platform-dependent.h \
   win32/vc-2010/rhash.vcxproj
 LIBRHASH_FILES  = librhash/algorithms.c librhash/algorithms.h \
-  librhash/byte_order.c librhash/byte_order.h librhash/rhash_timing.c librhash/rhash_timing.h \
-  librhash/plug_openssl.c librhash/plug_openssl.h librhash/rhash.c librhash/rhash.h \
+  librhash/byte_order.c librhash/byte_order.h librhash/plug_openssl.c librhash/plug_openssl.h \
+  librhash/rhash.c librhash/rhash.h librhash/rhash_torrent.c librhash/rhash_torrent.h \
+  librhash/rhash_timing.c librhash/rhash_timing.h \
   librhash/aich.c librhash/aich.h librhash/crc32.c librhash/crc32.h \
   librhash/ed2k.c librhash/ed2k.h librhash/edonr.c librhash/edonr.h \
   librhash/gost.c librhash/gost.h librhash/has160.c librhash/has160.h \
@@ -70,6 +72,7 @@
 
 install: all install-binary install-data install-symlinks
 install-shared: $(SHARED_TRG) install-shared-binary install-data install-symlinks
+install-data: install-man install-conf
 uninstall: uninstall-binary uninstall-data uninstall-symlinks
 
 # creating archives
@@ -87,23 +90,27 @@
 zip : $(ARCHIVE_ZIP)
 dgz:  check $(ARCHIVE_DEB_GZ)
 
-install-binary:
+mkdir-bin:
 	$(INSTALL) -d $(DESTDIR)$(BINDIR)
+
+install-binary: mkdir-bin
 	$(INSTALL_PROGRAM) $(TARGET) $(DESTDIR)$(BINDIR)
 
 # install dynamically linked binary
-install-shared-binary:
-	$(INSTALL) -d $(DESTDIR)$(BINDIR)
+install-shared-binary: mkdir-bin
 	$(INSTALL_PROGRAM) $(SHARED_TRG) $(DESTDIR)$(BINDIR)/rhash
 
-install-data:
-	$(INSTALL) -d $(DESTDIR)$(MANDIR)/man1 $(DESTDIR)/etc
+install-man:
+	$(INSTALL) -d $(DESTDIR)$(MANDIR)/man1
 	$(INSTALL_DATA) dist/rhash.1 $(DESTDIR)$(MANDIR)/man1/rhash.1
-	sed -e 's/\x0D//g' dist/rhashrc.sample > rhashrc && $(INSTALL_DATA) rhashrc $(DESTDIR)/etc/rhashrc
-	rm -f rhashrc
-
-# dependencies should be properly set, otherwise 'make -j<n>' can run install targets in parallel
-install-symlinks:
+
+install-conf:
+	$(INSTALL) -d $(DESTDIR)/etc
+	sed -e 's/\x0D//g' dist/rhashrc.sample > rc.tmp && $(INSTALL_DATA) rc.tmp $(DESTDIR)/etc/rhashrc
+	rm -f rc.tmp
+
+# dependencies should be properly set, otherwise 'make -j<n>' can fail
+install-symlinks: mkdir-bin install-man
 	for f in $(SYMLINKS); do ln -fs rhash $(DESTDIR)$(BINDIR)/$$f; done
 	cd $(DESTDIR)$(MANDIR)/man1 && for f in $(SYMLINKS); do ln -fs rhash.1* $$f.1; done
 
@@ -139,11 +146,11 @@
 
 test: test-static
 test-static: $(TARGET)
-	chmod +x tests/test_$(PROGNAME).sh
-	tests/test_$(PROGNAME).sh
+	chmod +x tests/test_rhash.sh
+	tests/test_rhash.sh
 
 test-shared: $(SHARED_TRG) test-shared-lib
-	chmod +x tests/test_$(PROGNAME).sh
+	chmod +x tests/test_rhash.sh
 	LD_LIBRARY_PATH=../librhash:$(LD_LIBRARY_PATH) tests/test_rhash.sh ./$(SHARED_TRG)
 
 version.h: Makefile
@@ -161,64 +168,59 @@
 	$(CC) $(OBJECTS) -o $@ $(ALLLDFLAGS)
 
 $(SHARED_TRG): $(OBJECTS) $(SHAREDLIB)
-	$(CC) $(OBJECTS) -o $(SHARED_TRG) $(SHRDLFLAGS)
+	$(CC) $(OBJECTS) $(SHRDLFLAGS) -o $(SHARED_TRG) $(SHAREDLIB)
 
 # NOTE: dependences were generated by 'gcc -Ilibrhash -MM *.c'
 # we are using plain old makefile style to support BSD make
-calc_sums.o: calc_sums.c common_func.h librhash/util.h librhash/hex.h \
- librhash/rhash.h librhash/rhash_timing.h parse_cmdline.h rhash_main.h \
- file_set.h calc_sums.h hash_check.h hash_print.h output.h win_utils.h \
+calc_sums.o: calc_sums.c common_func.h librhash/rhash.h \
+ librhash/rhash_torrent.h parse_cmdline.h rhash_main.h hash_print.h \
+ output.h win_utils.h calc_sums.h hash_check.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+common_func.o: common_func.c common_func.h win_utils.h parse_cmdline.h \
  version.h
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
-common_func.o: common_func.c common_func.h librhash/util.h librhash/hex.h \
- win_utils.h parse_cmdline.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-hash_print.o: hash_print.c common_func.h librhash/util.h librhash/hex.h \
- librhash/byte_order.h calc_sums.h librhash/rhash.h hash_check.h \
- parse_cmdline.h hash_print.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-hash_update.o: hash_update.c common_func.h librhash/util.h \
- librhash/rhash_timing.h win_utils.h parse_cmdline.h output.h rhash_main.h \
- file_set.h calc_sums.h librhash/rhash.h hash_check.h file_mask.h \
- hash_update.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-file_mask.o: file_mask.c common_func.h librhash/util.h file_mask.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-file_set.o: file_set.c librhash/hex.h librhash/crc32.h common_func.h \
- librhash/util.h hash_print.h parse_cmdline.h rhash_main.h output.h \
- file_set.h calc_sums.h librhash/rhash.h hash_check.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-find_file.o: find_file.c common_func.h librhash/util.h win_utils.h \
- find_file.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-hash_check.o: hash_check.c librhash/hex.h librhash/byte_order.h \
- librhash/rhash.h output.h parse_cmdline.h hash_print.h hash_check.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-output.o: output.c common_func.h librhash/util.h librhash/rhash.h \
- calc_sums.h hash_check.h parse_cmdline.h rhash_main.h output.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-parse_cmdline.o: parse_cmdline.c common_func.h librhash/util.h \
- librhash/rhash.h librhash/plug_openssl.h win_utils.h file_mask.h \
- hash_print.h output.h rhash_main.h version.h parse_cmdline.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-rhash_main.o: rhash_main.c common_func.h librhash/util.h \
- librhash/rhash_timing.h win_utils.h find_file.h file_set.h calc_sums.h \
- librhash/rhash.h hash_check.h hash_update.h file_mask.h hash_print.h \
- parse_cmdline.h output.h version.h rhash_main.h
-	$(CC) -c $(ALLCFLAGS) $< -o $@
-
-win_utils.o: win_utils.c common_func.h librhash/util.h parse_cmdline.h \
- rhash_main.h win_utils.h
+file_mask.o: file_mask.c common_func.h file_mask.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+file_set.o: file_set.c librhash/rhash.h common_func.h hash_print.h \
+ parse_cmdline.h rhash_main.h output.h file_set.h calc_sums.h \
+ hash_check.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+find_file.o: find_file.c common_func.h output.h win_utils.h find_file.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+hash_check.o: hash_check.c librhash/rhash.h output.h common_func.h \
+ parse_cmdline.h hash_print.h hash_check.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+hash_print.o: hash_print.c common_func.h librhash/rhash.h calc_sums.h \
+ hash_check.h parse_cmdline.h win_utils.h hash_print.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+hash_update.o: hash_update.c common_func.h win_utils.h parse_cmdline.h \
+ output.h rhash_main.h file_set.h calc_sums.h hash_check.h file_mask.h \
+ hash_print.h hash_update.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+output.o: output.c common_func.h librhash/rhash.h calc_sums.h \
+ hash_check.h parse_cmdline.h rhash_main.h win_utils.h output.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+parse_cmdline.o: parse_cmdline.c common_func.h librhash/rhash.h \
+ win_utils.h file_mask.h find_file.h hash_print.h output.h rhash_main.h \
+ parse_cmdline.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+rhash_main.o: rhash_main.c common_func.h librhash/rhash.h win_utils.h \
+ find_file.h calc_sums.h hash_check.h hash_update.h file_mask.h \
+ hash_print.h parse_cmdline.h output.h rhash_main.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
+win_utils.o: win_utils.c common_func.h parse_cmdline.h rhash_main.h \
+ win_utils.h
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
 dist/rhash.1.win.html: dist/rhash.1 dist/rhash.1.win.sed
@@ -239,7 +241,7 @@
 
 permissions:
 	find . dist librhash po win32 win32/vc-2010 -maxdepth 1 -type f -exec chmod -x '{}' \;
-	chmod +x tests/test_$(PROGNAME).sh
+	chmod +x tests/test_rhash.sh
 
 clean-bindings:
 	+make -C bindings distclean
@@ -309,3 +311,16 @@
 	xgettext *.c -k_ -cTRANSLATORS -o po/rhash.pot \
 		--msgid-bugs-address='Aleksey <rhash.admin@gmail.com>' --package-name='RHash'
 	for f in po/*.po; do \
+		msgmerge -U $$f po/rhash.pot; \
+	done
+
+compile-gmo:
+	for f in po/*.po; do \
+		g=`basename $$f .po`; \
+		msgfmt $$f -o po/$$g.gmo; \
+	done
+
+install-gmo: compile-gmo
+	for f in po/*.gmo; do \
+		l=`basename $$f .gmo`; \
+		$(INSTALL) -d $(DESTDIR)$(LOCALEDIR)/$$l/LC_MESSAGES; \

=== librhash/Makefile ===
--- 
+++ 
@@ -16,10 +16,12 @@
 ALLCFLAGS = $(LIBCFLAGS) $(PRGCFLAGS)
 LDRHASH    = -L. -lrhash
 LIBLDFLAGS = $(LDFLAGS) $(ADDLDFLAGS)
-HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_timing.h util.h aich.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h sha3.h ripemd-160.h gost.h has160.h snefru.h tiger.h              tth.h torrent.h whirlpool.h
-SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_timing.c util.c aich.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c sha3.c ripemd-160.c gost.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c whirlpool.c whirlpool_sbox.c
-OBJECTS = algorithms.o byte_order.o plug_openssl.o rhash.o rhash_timing.o util.o aich.o crc32.o ed2k.o edonr.o hex.o md4.o md5.o sha1.o sha256.o sha512.o sha3.o ripemd-160.o gost.o has160.o snefru.o tiger.o tiger_sbox.o tth.o torrent.o whirlpool.o whirlpool_sbox.o
-LIB_HEADERS = rhash.h rhash_timing.h
+HEADERS = algorithms.h byte_order.h plug_openssl.h rhash.h rhash_timing.h rhash_torrent.h util.h aich.h crc32.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h sha3.h ripemd-160.h gost.h has160.h snefru.h tiger.h              tth.h torrent.h whirlpool.h
+SOURCES = algorithms.c byte_order.c plug_openssl.c rhash.c rhash_timing.c rhash_torrent.c util.c aich.c crc32.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c sha3.c ripemd-160.c gost.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c whirlpool.c whirlpool_sbox.c
+OBJECTS = algorithms.o byte_order.o plug_openssl.o rhash.o rhash_timing.o rhash_torrent.o util.o aich.o crc32.o ed2k.o edonr.o hex.o md4.o md5.o sha1.o sha256.o sha512.o sha3.o ripemd-160.o gost.o has160.o snefru.o tiger.o tiger_sbox.o tth.o torrent.o whirlpool.o whirlpool_sbox.o
+LIB_HEADERS = rhash.h rhash_torrent.h
+LEGACY_LIB_HEADERS = rhash_timing.h
+SO_HEADERS = $(LIB_HEADERS) $(LEGACY_LIB_HEADERS)
 # installation directories and names
 DESTDIR =
 PREFIX  = /usr/local
@@ -119,6 +121,10 @@
  rhash_timing.h
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
+rhash_torrent.o: rhash_torrent.c algorithms.h rhash.h byte_order.h ustd.h \
+ config.h torrent.h sha1.h rhash_torrent.h
+	$(CC) -c $(ALLCFLAGS) $< -o $@
+
 ripemd-160.o: ripemd-160.c byte_order.h ustd.h config.h ripemd-160.h
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
@@ -138,7 +144,7 @@
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
 test_hashes.o: test_hashes.c byte_order.h ustd.h config.h rhash_timing.h \
- rhash.h test_hashes.h
+ rhash_torrent.h rhash.h test_hashes.h
 	$(CC) -c $(ALLCFLAGS) $< -o $@
 
 tiger.o: tiger.c byte_order.h ustd.h config.h tiger.h
@@ -176,7 +182,7 @@
 
 # shared and static libraries
 $(SONAME): $(SOURCES)
-	sed -n '1s/.*/{ global:/p; s/^RHASH_API.* \([a-z0-9_]\+\)(.*/  \1;/p; $$s/.*/local: *; };/p' $(LIB_HEADERS) > exports.sym
+	sed -n '1s/.*/{ global:/p; s/^RHASH_API.* \([a-z0-9_]\+\)(.*/  \1;/p; $$s/.*/local: *; };/p' $(SO_HEADERS) > exports.sym
 	$(CC) -fpic $(ALLCFLAGS) -shared $(SOURCES) -Wl,--version-script,exports.sym,-soname,$(SONAME) $(LIBLDFLAGS) -o $@
 	ln -s $(SONAME) $(SOLINK)
 # use 'nm -Cg --defined-only $@' to view exported symbols

=== debian/changelog ===
rhash (1.3.3-1) unstable; urgency=low

  * New upstream release version 1.3.3
  * librhash now exports new torrent interface

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Tue, 05 Aug 2014 02:12:06 +0700

rhash (1.3.2-2) unstable; urgency=low

  * fix symlinks installation when building the package

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Fri, 04 Jul 2014 02:53:00 +0700

rhash (1.3.2-1) unstable; urgency=low

  *  New upstream release version 1.3.2
   - fixed infinite loop while working with symlinks (Closes: #750842)
   - fixed the hardening-no-relro lintian warning

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Wed, 02 Jul 2014 01:41:59 +0700

=== debian/control ===
Source: rhash
Section: utils
Priority: optional
Maintainer: Aleksey Kravchenko <rhash.admin@gmail.com>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.2), libssl-dev (>= 1.0.0)
Standards-Version: 3.9.5
Homepage: http://rhash.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/collab-maint/rhash.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/rhash.git

Package: rhash
Architecture: any
Depends: librhash0 (>= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl1.0.0 (>= 1.0.0)
Description: utility for computing hash sums and magnet links
 RHash is a console utility for calculation and verification of magnet links
 and a wide range of hash sums like CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Output in a predefined (SFV, BSD-like) or a user-defined format.
  * Can calculate Magnet links.
  * Ability to process directories recursively.
  * Updating hash files (adding hash sums of files missing in the hash file).
  * Portability: the program works the same on Linux, *BSD or Windows.

Package: librhash0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl1.0.0 (>= 1.0.0)
Description: shared library for hash functions computing
 LibRHash is a professional, portable, thread-safe C library for computing
 magnet links and a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1,
 SHA256, SHA512, AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH,
 GOST R 34.11-94, RIPEMD-160, HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Small and easy to learn interface.
  * Hi-level and Low-level API.
  * Allows calculating of several hash functions simultaneously.
  * Portability: the library works on Linux, *BSD and Windows.

Package: librhash-dev
Architecture: any
Section: libdevel
Depends: librhash0 (= ${binary:Version}), ${misc:Depends}
Description: header files and a static library for librhash
 LibRHash is a professional, portable, thread-safe C library for computing
 magnet links and a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1,
 SHA256, SHA512, AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH,
 GOST R 34.11-94, RIPEMD-160, HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains LibRHash static library and header files.

Package: librhash0-dbg
Architecture: any
Section: debug
Priority: extra
Depends: librhash0 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for librhash
 LibRHash is a professional, portable, thread-safe C library for computing
 magnet links and a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1,
 SHA256, SHA512, AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH,
 GOST R 34.11-94, RIPEMD-160, HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains debug information for the librhash shared library.

=== debian/rules ===
--- 
+++ 
@@ -25,8 +25,8 @@
 
 # by default compile RHash with openssl runtime linking
 ifeq (,$(findstring nossl,$(DEB_BUILD_OPTIONS)))
+ifneq (,$(findstring ssldynamic,$(DEB_BUILD_OPTIONS)))
 	LIBCFLAGS += -DUSE_OPENSSL
-ifneq (,$(findstring ssldynamic,$(DEB_BUILD_OPTIONS)))
 	LIBLDFLAGS += -lcrypto
 else
 	LIBCFLAGS  += -DOPENSSL_RUNTIME -rdynamic
@@ -45,10 +45,16 @@
 
 override_dh_auto_build:
 override_dh_auto_test:
-	$(MAKE) test-static-lib CFLAGS="$(CFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)"
-	$(MAKE) test-shared CFLAGS="$(CFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)" LD_LIBRARY_PATH="$(LD_LIB)"
+	# note: static and shared libraries will be built if not exist yet
+	$(MAKE) test-static-lib CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
+		LIBCFLAGS="$(LIBCFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)"
+	$(MAKE) test-shared CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
+		LIBCFLAGS="$(LIBCFLAGS)" LIBLDFLAGS="$(LIBLDFLAGS)" LD_LIBRARY_PATH="$(LD_LIB)"
 
 override_dh_auto_install:
+	# v1.3.2: quick fix for fail on parallel build
+	install -d $(CURDIR)/debian/rhash/usr/bin
+	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/rhash INSTALL_PROGRAM="$(INSTALL_PROGRAM)" install-data
 	# Install the program and its translation strings
 	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/rhash INSTALL_PROGRAM="$(INSTALL_PROGRAM)" install-shared install-gmo
 	# Install static library
